#include "sortiva.hpp"

#include <cstdlib>
#include <stdio.h>

#include <cstdint>
#include <memory>


namespace rl
{
#include <raylib.h>
}


Sortiva::Sortiva()
{
	rl::InitWindow(1280, 720, "Sortiva");
	if (!rl::IsWindowReady()) exit(2);

	m_Width = rl::GetRenderWidth();
	m_Height = rl::GetRenderHeight();
	rl::SetWindowMinSize(static_cast<int>(1280 * 0.25f), static_cast<int>(720 * 0.25f));
	rl::SetWindowState(rl::ConfigFlags::FLAG_WINDOW_RESIZABLE | rl::ConfigFlags::FLAG_VSYNC_HINT);

	rl::SetTargetFPS(60);
}

Sortiva::~Sortiva()
{
	rl::CloseWindow();
}

void Sortiva::run()
{
	setup();
	while (m_Running)
	{
		if (rl::WindowShouldClose()) m_Running = false;
		if (rl::IsWindowResized())
		{
			m_Width = rl::GetScreenWidth();
			m_Height = rl::GetScreenHeight();
		}

		rl::ClearBackground({ 25, 25, 25, 255 });
		rl::BeginDrawing();

		update(rl::GetFrameTime());
		draw();

		rl::EndDrawing();
	}
}

void Sortiva::setup()
{
	m_Steps.reset();
	m_Steps = std::make_unique<val_step_diag>();



	m_Steps->emplace_back();
	m_Steps->emplace_back();
	m_Steps->emplace_back();

	linked_list<uint16_t>& list1 = m_Steps->at(0);
	list1.value = 1;
	list1.put(1).put(3).put(1).put(1);
	//
	linked_list<uint16_t>& list2 = m_Steps->at(1);
	list2.value = 3;
	list2.put(2).put(1).put(3).put(2);
	//
	linked_list<uint16_t>& list3 = m_Steps->at(2);
	list3.value = 2;
	list3.put(3).put(2).put(2).put(3);

}
